import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class TextEditor extends Frame{

    //    Button n, o, s, q;
    MenuBar mb;
    Menu menu ;
    MenuItem n,s,q,o;
    TextArea ta;
    MenuShortcut racc_save; // (pour sauver, faire F12)

    public TextEditor(String titre){
	
        super(titre);
        setFont(new Font("Serif",Font.BOLD,12));
	MenuBar mb = new MenuBar();
	Menu menu = new Menu("File");
	MenuItem n = new MenuItem("New");
	MenuItem s = new MenuItem("Save");
	MenuItem q = new MenuItem("Quit");
	MenuItem o = new MenuItem("Open");
	MenuShortcut racc_save = new MenuShortcut(KeyEvent.VK_F12);

	q.addActionListener(new ActionQuit(this));
	n.addActionListener(new ActionNew(this));
	s.addActionListener(new ActionSave(this));
	o.addActionListener(new ActionOpen(this));

	s.setShortcut(racc_save);

	menu.add(n);menu.add(o);menu.add(s);menu.add(q);
	mb.add(menu);
	setMenuBar(mb);

	ta = new TextArea ("coucou!",30,50);
	ta.setBackground(Color.gray);
	add(ta);

    }
    // Actions effectues lors des appels de menu //

    public void newfile(){
	ta.setText("");}

    public void quit(){
	System.exit(0);}

    public void open() throws PbFichierErreur{
	FileDialog fdo = new FileDialog(this,"ouvrir",FileDialog.LOAD);
	fdo.setVisible(true);
	String file_name = fdo.getFile();
	FileReader fr;

	try{
	    fr = new FileReader(file_name);
	}
	catch(FileNotFoundException e)
	    {
		throw new PbFichierErreur("je ne trouve pas le fichier");
	    }

	String res = "";

	try{
	    int c  =fr.read(); 

	    
	    while (c != -1) {
		res+=(char)c;
		c=fr.read();
	    }
	}
	catch(IOException e)
	    {
		throw new PbFichierErreur("pb de lecture dans le fichier");
	    }
	
	ta.setText(res);
    }

    public void save() throws PbFichierErreur{
	FileDialog fds = new FileDialog(this,"sauver",FileDialog.SAVE);
	fds.setVisible(true);
	String file_name = fds.getFile();
	FileWriter fw;
	
	try{	
	    fw = new FileWriter(file_name);
	    fw.write(ta.getText());
	    fw.close();
	}
	catch(Exception e)
	    {
		throw new PbFichierErreur("je n'arrive pas  sauver le fichier");
	    }
    }

    // Leurs couteurs

    class ActionNew implements ActionListener
    {
	TextEditor te;
	ActionNew(TextEditor t)
	{
	    te=t;
	}	
	public void actionPerformed(ActionEvent e)
	{
	    te.newfile();
	}

    }

    class ActionQuit implements ActionListener
    {
	TextEditor te;
	ActionQuit(TextEditor t)
	{
	    te=t;
	}
	
	public void actionPerformed(ActionEvent e)
	{
	    te.quit();
	}
    }
	
    class ActionOpen implements ActionListener
    {
	TextEditor te;
	ActionOpen(TextEditor t)
	{
	    te=t;
	}
	
	public void actionPerformed(ActionEvent e)
	{
	    try{
		te.open();
	    }
	    catch (PbFichierErreur f)
		{
		   
		}
	}
    }

    class ActionSave implements ActionListener
    {
	TextEditor te;
	ActionSave(TextEditor t)
	{
	    te=t;
	}
	
	public void actionPerformed(ActionEvent e)
	{

	    try{
		te.save();
	    }
	    catch (PbFichierErreur f)
		{
		    
		}
	    }
	}



    
    // Le programme principal //
    
    public static void main(String args[]) 
    {
	
        TextEditor f = new TextEditor("Mon diteur");
	f.setBackground(Color.lightGray);
	//WindowListener l = new WindowListener();	
	//f.addWindowListener(l);
        f.pack();
        f.setVisible(true);
    }


}


